package at.jku.students.binarytree;

import at.jku.ssw.set.BinaryTreeNode;
import at.jku.ssw.set.impl.BinaryTreeSet;

public class BinaryTreeUtil {

	/**
	 * Returns an array of length {@link BinaryTreeSet#size} which contains the
	 * values of the {@code tree} according to the <em>inorder</em>-traversal of
	 * the tree.
	 * 
	 * <h3>Example</h3> Tree:
	 * 
	 * <pre>
	 *   A
	 *  / \
	 * B   C
	 * </pre>
	 * 
	 * Result:
	 * 
	 * <pre>
	 * [B, A, C]
	 * </pre>
	 */
	public static int[] inorder(BinaryTreeSet tree) {
		// TODO
		return null;
	}

	/**
	 * Returns an array of length {@link BinaryTreeSet#size} which contains the
	 * values of the {@code tree} according to the <em>preorder</em>-traversal
	 * of the tree.
	 * 
	 * <h3>Example</h3> Tree:
	 * 
	 * <pre>
	 *   A
	 *  / \
	 * B   C
	 * </pre>
	 * 
	 * Result:
	 * 
	 * <pre>
	 * [A, B, C]
	 * </pre>
	 */
	public static int[] preorder(BinaryTreeSet tree) {
		// TODO
		return null;
	}

	/**
	 * Returns an array of length {@link BinaryTreeSet#size} which contains the
	 * values of the {@code tree} according to the <em>postorder</em>-traversal
	 * of the tree.
	 * 
	 * <h3>Example</h3> Tree:
	 * 
	 * <pre>
	 *   A
	 *  / \
	 * B   C
	 * </pre>
	 * 
	 * Result:
	 * 
	 * <pre>
	 * [B, C, A]
	 * </pre>
	 */
	public static int[] postorder(BinaryTreeSet tree) {
		// TODO
		return null;
	}

	/**
	 * Reconstructs a {@link BinaryTreeSet binary tree} from an <em>inorder</em>
	 * and a <em>preorder</em> traversal.
	 * 
	 * <h3>Example</h3>
	 *
	 * <pre>
	 *  inorder: [B, A, C]
	 * preorder: [A, B, C]
	 * </pre>
	 * 
	 * Result:
	 * 
	 * <pre>
	 *   A
	 *  / \
	 * B   C
	 * </pre>
	 * 
	 * @throws IllegalArgumentException
	 *             if the {@code inorder} and {@code preorder} arrays are
	 *             inconsistent (e.g. wrong size, missing value, wrong
	 *             ordering).
	 */
	public static BinaryTreeSet buildTree(int[] inorder, int[] preorder) {
		// TODO
		return null;
	}
}
